"use strict";
(function ($, w) {
  var $window = $(w);
  $window.on("elementor/frontend/init", function () {

    //SmartPostList

    var SmartPostList = function SmartPostList($scope) {
      var filterWrap = $scope.find(".bwdsplx-spl-filter"),
          customSelect = $scope.find(".bwdsplx-spl-custom-select"),
          gridWrap = $scope.find(".bwdsplx-spl-grid-area"),
          mainWrapper = $scope.find(".bwdsplx-spl-wrapper"),
          querySettings = mainWrapper.data("settings"),
          dataOffset = mainWrapper.attr("data-offset"),
          nav = $scope.find(".bwdsplx-spl-pagination button"),
          navPrev = $scope.find(".bwdsplx-spl-pagination button.prev"),
          navNext = $scope.find(".bwdsplx-spl-pagination button.next"),
          filter = $scope.find("ul.bwdsplx-spl-filter-list li span"),
          event;
      customSelect.niceSelect();
      var select = $scope.find(".bwdsplx-spl-custom-select li");

      function afterClick(e) {
        e.preventDefault();
        var $self = $(this),
            dataFilter = filterWrap.attr("data-active"),
            dataTotalOffset = mainWrapper.attr("data-total-offset"),
            offset = "",
            termId = "";

        if (e.target.classList.contains("prev") || e.target.classList.contains("fa-angle-left")) {
          if (0 == parseInt(dataTotalOffset)) {
            navPrev.attr("disabled", true);
            return;
          }

          offset = 0 !== parseInt(dataTotalOffset) ? parseInt(dataTotalOffset) - parseInt(dataOffset) : "0";

          if (undefined !== dataFilter) {
            termId = dataFilter;
          }
        } else if (e.target.classList.contains("next") || e.target.classList.contains("fa-angle-right")) {
          offset = parseInt(dataTotalOffset) + parseInt(dataOffset);

          if (undefined !== dataFilter) {
            termId = dataFilter;
          }
        }

        if (e.target.hasAttribute("data-value")) {
          termId = e.target.dataset["value"];
          filterWrap[0].setAttribute("data-active", termId);

          if ("SPAN" === e.target.tagName) {
            filter.removeClass("bwdsplx-active");
            e.target.classList.toggle("bwdsplx-active");
          }

          offset = 0;
          navPrev.attr("disabled", true);
          navNext.removeAttr("disabled");
        }

        $.ajax({
          url: BwdProLocalize.ajax_url,
          type: "POST",
          data: {
            action: "bwdsplx_smart_post_list_action",
            security: BwdProLocalize.nonce,
            querySettings: querySettings,
            offset: offset,
            termId: termId
          },
          success: function success(response) {
            if ($(response).length > 0) {
              gridWrap.css("height", gridWrap.outerHeight(true) + "px");
              gridWrap.html("");
              $(response).appendTo(gridWrap);
              gridWrap.css("height", "");
              mainWrapper[0].attributes["data-total-offset"].value = offset;

              if (e.target.classList.contains("prev") || e.target.classList.contains("fa-angle-left")) {
                navNext.removeAttr("disabled");
              }

              if (e.target.classList.contains("next") || e.target.classList.contains("fa-angle-right")) {
                navPrev.removeAttr("disabled");
              }
            } else {
              if (e.target.classList.contains("next") || e.target.classList.contains("fa-angle-right")) {
                navNext.attr("disabled", true);
              }
            }
          },
          error: function error(_error3) {}
        });
      }

      nav.on("click", afterClick);
      filter.on("click", afterClick);
      select.on("click", afterClick);
    };

    elementorFrontend.hooks.addAction("frontend/element_ready/bwdsplx-smart-post-list.default", SmartPostList);

  });
})(jQuery, window);