<?php
namespace bwdsplx_SmartPostList_namespace\controls;

use Elementor\Base_Data_Control;
use bwdsplx_SmartPostList_namespace\Lazy_Query_Manager;

defined( 'ABSPATH' ) || die();
class Lazy_Select extends Base_Data_Control {

	/**
	 * Control identifier
	 */
	const TYPE = 'bwdsplx-lazy-select';

	/**
	 * Set control type.
	 */
	public function get_type() {
		return self::TYPE;
	}

	/**
	 * Enqueue control scripts and styles.
	 */
	public function enqueue() {
		wp_enqueue_script(
			'bwdsplx-lazy-select',
			bwdsplx_ASFSK_ASSETS_ADMIN_DIR_FILE . '/js/lazy-select.min.js', [ 'jquery' ], Smart_Post_List_VERSION, true );

		wp_localize_script(
			'bwdsplx-lazy-select',
			'bwdsplx_lazy',
			[
				'nonce' => wp_create_nonce( Lazy_Query_Manager::ACTION ),
				'action' => Lazy_Query_Manager::ACTION,
				'ajax_url' => admin_url( 'admin-ajax.php' )
			]
		);
	}
	protected function get_default_settings() {
		return [
			'options' => [],
			'multiple' => false,
			'select2options' => [],
			'lazy_args' => []
		];
	}
	public function content_template() {
		$control_uid = $this->get_control_uid();
		?>
		<div class="elementor-control-field">
			<# if ( data.label ) {#>
			<label for="<?php echo $control_uid; ?>" class="elementor-control-title">{{{ data.label }}}</label>
			<# } #>
			<div class="elementor-control-input-wrapper">
				<# var multiple = ( data.multiple ) ? 'multiple' : ''; #>
				<select id="<?php echo $control_uid; ?>" class="elementor-select2" type="select2" {{ multiple }} data-setting="{{ data.name }}">
					<# _.each( data.options, function( option_title, option_value ) {
					var value = data.controlValue;
					if ( typeof value == 'string' ) {
					var selected = ( option_value === value ) ? 'selected' : '';
					} else if ( null !== value ) {
					var value = _.values( value );
					var selected = ( -1 !== value.indexOf( option_value ) ) ? 'selected' : '';
					}
					#>
					<option {{ selected }} value="{{ option_value }}">{{{ option_title }}}</option>
					<# } ); #>
				</select>
			</div>
		</div>
		<# if ( data.description ) { #>
		<div class="elementor-control-field-description">{{{ data.description }}}</div>
		<# } #>
		<?php
	}
}