<?php
if (!defined( 'ABSPATH')) {
    exit;
}

function bwdsplx_SmartPostList_addon_failed_load() {
    $check_display = get_current_screen();
	if (isset( $check_display->parent_file) && 'plugins.php' === $check_display->parent_file && 'update' === $check_display->id) {
		return;
	}
	$bwdsplx_plugin_plugin = 'elementor/elementor.php';
	if (bwdsplx_addon_install()) {
		if (!current_user_can('activate_plugins')) {
			return;
		}
		$bwdsplx_plugin_active_url = wp_nonce_url('plugins.php?action=activate&plugin=' . $bwdsplx_plugin_plugin . '&plugin_status=all&paged=1&s', 'activate-plugin_' . $bwdsplx_plugin_plugin );
		$bwd_plugin_the_notice_is = '<p><b>Smart Post List</b> requires Elementor to be activated.</p>';
        $bwd_plugin_the_notice_is .= '<p><a href="'. $bwdsplx_plugin_active_url .'" class="button-primary">Activate Elementor</a></p>';
	} else {
		if (!current_user_can('install_plugins')) {
			return;
		}
		$install_url = wp_nonce_url(self_admin_url('update.php?action=install-plugin&plugin=elementor'), 'install-plugin_elementor');
		$bwd_plugin_the_notice_is = '<p><b>Smart Post List</b> requires Elementor to be installed and activated.</p>';
		$bwd_plugin_the_notice_is .= '<p><a href="'. $install_url .'" class="button-primary">Install Elementor</a></p>';
	}
	echo '<div class="notice notice-error"><p>' . $bwd_plugin_the_notice_is . '</p></div>';
}

function bwdsplx_admin_notice_minimum_elementor_version() {

	if (!current_user_can('update_plugins')) {
		return;
	}
	$file_path = 'elementor/elementor.php';
    $upgrade_link = wp_nonce_url(self_admin_url('update.php?action=upgrade-plugin&plugin=') . $file_path, 'upgrade-plugin_' . $file_path);
	$bwd_plugin_the_notice_is = '<p><b>Smart Post List</b> does not work since you are using an older version of Elementor</p>';
    $bwd_plugin_the_notice_is .= '<p><a href="'. $upgrade_link .'" class="button-primary">Update Elementor</a></p>';
	echo '<div class="notice notice-error">' . $bwd_plugin_the_notice_is . '</div>';
}

function bwdsplx_addon_install() {
    $file_path = 'elementor/elementor.php';
    $installed_plugins = get_plugins();

    return isset($installed_plugins[$file_path]);
}

function bwdsplx_pro_get_taxonomies()
{
	$taxonomies = get_taxonomies(['show_in_nav_menus' => true], 'objects');

	$options = ['' => ''];

	foreach ($taxonomies as $taxonomy) {
		$options[$taxonomy->name] = $taxonomy->label;
	}

	return $options;
}
function bwdsplx_pro_the_first_taxonomy($post_id = null, $taxonomy_id = null, $args = [])
{
	if (empty($taxonomy_id)) {
		return;
	}
	if (empty($post_id)) {
		$post_id = get_the_ID();
	}


	$args = wp_parse_args($args, [
		'class' => 'bwdsplx-pg-badge-taxonomy',
	]);

	$terms = get_the_terms($post_id, $taxonomy_id);
	if (empty($terms[0])) {
		return;
	}


	return sprintf(
		'<a href="%s" class="%s" rel="tag">%s</a>',
		esc_url(get_term_link($terms[0]->term_id)),
		esc_attr($args['class']),
		esc_html($terms[0]->name)
	);
}
if (!function_exists('bwdsplx_escape_tags')) {
	function bwdsplx_escape_tags($tag, $default = 'span', $extra = []) {

		$supports = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'div', 'span', 'p'];

		$supports = array_merge($supports, $extra);

		if (!in_array($tag, $supports, true)) {
			return $default;
		}

		return $tag;
	}
}
function bwdsplx_pro_get_excerpt($post_id = null, $length = 15)
{
	if (empty($post_id)) {
		$post_id = get_the_ID();
	}

	return wp_trim_words(get_the_excerpt($post_id), $length);
}

